----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 03/26/2025 09:54:33 AM
-- Design Name: 
-- Module Name: tb_ecgUnit - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity tb_ecgUnit is
--  Port ( );
end tb_ecgUnit;

architecture Behavioral of tb_ecgUnit is

begin


end Behavioral;


-------------------------------------------------------------------------------
-- Title      : FirUnit
-- Project    : 
-------------------------------------------------------------------------------
-- File       : operativeUnit.vhd
-- Author     : Jean-Noel BAZIN  <jnbazin@pc-disi-026.enst-bretagne.fr>
-- Company    : 
-- Created    : 2018-04-11
-- Last update: 2019-02-26
-- Platform   : 
-- Standard   : VHDL'93/02
-------------------------------------------------------------------------------
-- Description: 8 bit FIR
-------------------------------------------------------------------------------
-- Copyright (c) 2018 
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2018-04-11  1.0      jnbazin Created
-- 2018-04-18  1.1      marzel	Modified to add more test inputs
-- 2019-02-26  1.1      marzel  Adapted to 16-tap filtering
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tb_ecgUnit is
end entity tb_ecgUnit;

architecture archi_tb_ecgUnit of tb_ecgUnit is
  component ecgUnit is
    port (
      I_clock               : in  std_logic;  -- global clock
    I_reset               : in  std_logic;  -- asynchronous global reset
    I_inputSample         : in  std_logic_vector(10 downto 0);  -- 8 bit input sample
    I_inputSampleValid    : in  std_logic;
    O_filteredSample      : out std_logic_vector(10 downto 0)  -- filtered sample
    );
  end component ecgUnit;

  signal SC_clock               : std_logic := '0';
  signal SC_reset               : std_logic;
  signal SC_inputSample         : std_logic_vector(10 downto 0);
  signal SC_inputSampleValid    : std_logic:='0';
  signal SC_filteredSample      : std_logic_vector(10 downto 0);
  signal SC_filteredSampleValid : std_logic;

begin

  SC_clock <= not SC_clock after 5 ns;
  SC_reset <= '0', '1' after 19 ns, '0' after 57 ns;

  -- Sample period = 20 clk period
  SC_inputSampleValid <= not SC_inputSampleValid after 100 ns;

  -- Null signal followed by a Dirac and then an arbitrary sequence
SC_inputSample <= std_logic_vector(to_signed(-17,11)),  -- -17
                  std_logic_vector(to_signed(-16,11)) after 1295 ns,  -- -16
                  std_logic_vector(to_signed(-14,11)) after 2695 ns;  -- -14
                 
    


  ecgUnit_1 : entity work.ecgUnit
    port map (
      I_clock               => SC_clock,
      I_reset               => SC_reset,
      I_inputSample         => SC_inputSample,
      I_inputSampleValid    => SC_inputSampleValid,
      O_filteredSample      => SC_filteredSample
      );
end architecture archi_tb_ecgUnit;